/* ###############################################
   # Copyright 2002       Roberto Borgione       #
   #                                             #
   # distr.c - Distribution parser and calc.     #
   #       v2.0 (03-2002)                        #
   ###############################################
 
   This file is part of NetMeter.

   NetMeter is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   NetMeter is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with NetMeter; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

// prompt command:  - - 0 1 1 100 1 100 100 1 1 1 - h:/work/data1b.dly 1 h:/work/data1n.dly 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

// const --------------------------

#define DIRECTORY_FILE_OUT "temp/"    // relative to ./netmeter/DIRECTORY_OUT
#define MAX_graphic_points  1500
#define MAX_LINE_LENGHT  300
#define MAX_INPUT_FILES  25
#define first_file 14
#define TRANSITORY_LINES 30   // how many lines of the file have to jump!!!


char Ytitle[9][40]={              "% of packets",     "% of packets"," EMPTY"," EMPTY","delay (msec)",    "unkown",                      "% of packets" ,                 "IPDV","unknown"};
char Xtitle[9][40]={              "delay (msec)",      "ipdv (msec)"," EMPTY"," EMPTY","packet sequence number",   "unknown","distance from average delay (msec)","packet sequence number","unknown"};
char   task[9][60]={"One-Way delay distribution","IPDV distribution"," EMPTY"," EMPTY","One-Way delay","UPDATE MCL",        "One-Way delay distribution",                  "IPDV","unknown"};
char   flag[2][40]={"disable","enable"};

// var ----------------------------

  float old_gap,old_min;
  float   flow_max[MAX_INPUT_FILES];
  float   flow_min[MAX_INPUT_FILES];
  char  fnames[MAX_INPUT_FILES][300];
  int   nflows[MAX_INPUT_FILES];
  float average[MAX_INPUT_FILES];
  float auxvar,total_delay;
  float gap;
  long  var;
  int   countp,countf,count,countx,county,countk,temp;
  char   hor1[3], min1[3],  sec1[10];
  char   hor2[3], min2[3],  sec2[10],seq[10];
  int   _hor1,   _min1;
  int   _hor2,   _min2;
  float _sec1;
  float _sec2;
  int   SeqNum,last_SeqNum,max_SeqNum,min_SeqNum;
  char  size[300];
  FILE *fout=NULL;
  FILE *f=NULL;
  char *fout_name,opt,out_name[300];
  char  proc[30];
  float delay,min,max,aux,last,ipdv;
  int   fnum,x;
  int   graphic_points;
  float var1,var2;
  float   count_dat[MAX_INPUT_FILES];
  int     pack_size[MAX_INPUT_FILES];
  char   flow_title[30][300];
  char   argv_min[20],argv_max[20];
  char        line3[MAX_LINE_LENGHT];
  char        line2[MAX_LINE_LENGHT];
  char         line[MAX_LINE_LENGHT];
  FILE        *faux[MAX_INPUT_FILES];
  float    vartotal[MAX_INPUT_FILES];
  unsigned int dist[MAX_INPUT_FILES][MAX_graphic_points+1];
  int time_stamp_offset,fixed_flow,read_flow;
  char ipver, flownumber[10];
  int trans;
  float real_step;
  float real_size;
  char minf,maxf; 


  //  vars for update_File
   FILE *ft;
   int data1,data2;
   int first;
   char stemp[300];
   int countflow;
   char *ptr;
   char counta,countb,countc;
   FILE *fm;

   char mname[300];
   char xname[300];
   char xline[500], yline[500];


// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void open_all_temp_files( void )
{
   for(countf=0; countf<fnum; countf++)   // opens all output file generated
   {
      proc[4]=(int)(countf + '0');
      faux[countf]=fopen(fout_name,"r");
   }
}



// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void close_all_temp_files( void )
{
   for(countf=0;countf<fnum;countf++)fclose(faux[countf]);
}


// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void process_IPDV_ONEWAY (void)           // (OW-DELAY) or (IPDV)
{
   max=max+0.0002;
   min=min-0.0002;

   if(strcmp(argv_min,"-")) min=(atof(argv_min))*0.001;
   if(strcmp(argv_max,"-")) max=(atof(argv_max))*0.001;

   open_all_temp_files();
   gap=(max-min);
   real_size=graphic_points;
   real_step=gap/real_size;

   for(countf=0; countf<fnum; countf++)
   {
      while(!feof(faux[countf]))
      {
   	 fgets(line,256,faux[countf]);
	 if (feof(faux[countf])) break;
	 delay=atof(line);
         var=(delay-min)/real_step;
         if ( (var>graphic_points) || (var<0) )
         {
            printf(" fatal RANGE_VALUE error.....!!!");
            //exit(-1);
         }
         else dist[countf][var]++;
      }
   }
   close_all_temp_files();
   f=fopen("graphDAT","w");
   for (countp=0; countp<=graphic_points; countp++)
   {
      fprintf(f,"%.2f ", (min+countp*real_step)*1000);  // time in msec
      for(countf=0; countf<fnum; countf++)         // axis-y  in %
      {
	 fprintf(f,"%f ",100*dist[countf][countp]/count_dat[countf]);
      }
      fprintf(f,"\n");
   }
   fclose(f);
}



// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void process_HEAD (void)           // transitory samples
{
   open_all_temp_files();
   f=fopen("graphDAT","w");
   for (count=0; count<graphic_points; count++)
   {
      fprintf(f,"%d ",count);
      for(countf=0; countf<fnum; countf++)
      {
   	 fgets(line,256,faux[countf]);
	 delay=atof(line);
         fprintf(f,"%f ",delay*1000);
      }
      fprintf(f,"\n");
   }
   close_all_temp_files();
}



//###### internal of update MCL files ###############################
      void update_file(void)
      {
         if (data1==0)
         {
            fputs("Update Data1:\n",ft);
            fputs("-[calc] Average Delay (sec):",ft);
            sprintf(stemp," %f\n", average[countk]);
            fputs(stemp,ft);
            fputs("-[calc] Variance (msec^2):",ft);
            sprintf(stemp," %f\n", vartotal[countk]);
            fputs(stemp,ft);
            fputs("-[calc] Standard deviation (msec) :",ft);
            sprintf(stemp," %f\n", sqrtf(vartotal[countk]) );
            fputs(stemp,ft);
         }
       }
//#############################################################

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
int  process_UPDATE_MCL(void)
{
   open_all_temp_files();
   for(countf=0; countf<fnum; countf++)
   {
      auxvar=0;
      while(!feof(faux[countf]))
      {
      	 fgets(line,256,faux[countf]);  // add#num[sqr(x-aver.)]/#num
 	 if (feof(faux[countf])) break;
         delay=atof(line);
         
         //printf("\n delay IN = %f",delay);
         //printf(" -  average =  %f",average[countf]);

         var1=delay*1000-average[countf]*1000;   // for better precision time->msec
         //printf(" -x= %f",var1);
         delay=var1*var1;          // simple SQR :(
         //printf(" -x*x=  %f",delay);
         auxvar = auxvar + delay;
      }
      auxvar=auxvar/count_dat[countf];        // time -> sec  
      vartotal[countf]=auxvar;
      printf("\n\n Variance  IN = %f\n\n",vartotal[countf]);
   }
   close_all_temp_files();
   for(countk=0; countk<fnum; countk++)
   {
      strcpy(mname,fnames[countk]);
      mname[strlen(mname)-3]='m';
      mname[strlen(mname)-2]='c';
      mname[strlen(mname)-1]='l';

      strcpy(xname,fnames[countk]);
      xname[strlen(xname)-3]='t';
      xname[strlen(xname)-2]='m';
      xname[strlen(xname)-1]='p';


      //printf("\n Xname = %s",xname);
      //printf("\n Mname = %s",mname);
      //printf("\n\n");

      ft=fopen(xname,"w");
      fm=fopen(mname,"r");
      if (fm==NULL) {
         fclose(ft);
         printf("\n MGEN - Distribution generator:\n\n ERROR...!!! MCL file not found.\n");
         return(-1);
      }
      else
      {
         data1=0;
         data2=0;
         countflow=0;
         while(!feof(fm))
         {
            fgets(xline,500,fm);
            if (feof(fm))  break;
            if (countflow==nflows[countk])
            {
               if (!strncmp(xline,"Update Data1:",13)) data1=1;
            }
            if (!strncmp(xline,"Mgen measure",12)) countflow++;
         }
         fseek(fm, 0L, 0);

         first=0;
         countflow=0;
         while(!feof(fm))
         {
            fgets(xline,500,fm);
            if (feof(fm))  break;
            if (!strncmp(xline,"Mgen measure",12))
            {
               if (countflow==nflows[countk])
               {
                   update_file();
                   first=1;
               }
               countflow++;
            }
            fputs(xline,ft);
         }
      }
      if (first==0) update_file();
      fclose(ft);
      fclose(fm);
      remove(mname);
      rename(xname,mname);
   }
}




// -------------------------------------------------------------------
//        Check the input file and examine IPversion used
// -------------------------------------------------------------------
void  check_input_file(char *name)
{
   int countflow;
   char *ptr;
   char counta,countb,countc;
   FILE *fm;
   char mname[300];
   char xline[500];

   f=fopen(name,"r");
   if (f==NULL)
   {
      printf("\n MGEN - Distribution generator:\n\n ERROR...!!! Input file not found.\n");
      exit (-1);
   }
   fgets(line,256,f);
   ptr = strstr(line,"TxTime");
   // set the offset for the TxTIME for different type of files (IPv4, IPv6)
   time_stamp_offset=ptr-line+7;
   counta=0;              // look for the address type searching for @N.N.N.N
   for (countb=0; countb<30; countb++)
     if (line[ptr-line-countb]=='.') counta++;
   if (counta>=2) ipver='4';
   else           ipver='6';
   printf("\n - detected for file %s flows with IP version: ipv%c",name,ipver);

   //reading the packet size for specifed flow
   read_flow=1977;   // magic number ;-)
   while (read_flow!=fixed_flow)
   {
      fgets(line,256,f);
      if (feof(f))  break;
      strncpy(flownumber, &line[5], 4);
      read_flow=atoi(flownumber);
   }
   if (read_flow==fixed_flow)
   {
      ptr = strstr(line,"Size");
      strncpy(size, &line[ptr-line+5], 20);
      pack_size[countk]=atoi(size);
   }

   // Reading if available the title in the MCL file for CGRAPH file
   strcpy(flow_title[countk],size);  // default title is pack. size
   flow_title[countk][strlen(flow_title[countk])-1]=' ';

   strcpy(mname,name);
   mname[strlen(mname)-3]='m';
   mname[strlen(mname)-2]='c';
   mname[strlen(mname)-1]='l';
   fm=fopen(mname,"r");
   if (fm==NULL) printf("\n MGEN - Distribution generator:\n\n WARNING...!!! MCL file not found.\n");   else
   {
      countflow=1;
      while(!feof(fm))
      {
         fgets(xline,500,fm);
         if (feof(fm))  break;
         if (!strncmp(xline,"Mgen measure",12))
         {
            if (countflow==fixed_flow)
            {
               fgets(xline,500,fm);
               strncpy(flow_title[countk],&xline[11],strlen(line)-11);
               flow_title[countk][strlen(xline)-11]='\0';
               // filter  ONLY CR for GRAPH label style :)
               for (countc=0; countc<strlen(flow_title[countk]); countc++)
                 if ((flow_title[countk][countc]=='\n'))
                   flow_title[countk][countc]='\0';
            }
            countflow++;
         }
      }
   }
   fclose(fm);
   fseek(f, 0L, 0);

}



// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void process_ONEWAY_COMPARE(void)           // (OW-DELAY compare)
{

   int FX_factor;

   // re-make graphic range
   old_gap=(max-min);
   old_min=min-0.0002;
   min=10000;
   max=0.000001;
   for(countk=0; countk<fnum; countk++)
   {
      flow_min[countk]=flow_min[countk]-average[countk];
      flow_max[countk]=flow_max[countk]-average[countk];
      if (flow_max[countk]>max)  max=flow_max[countk];
      if (flow_min[countk]<min)  min=flow_min[countk];
   }
   // -------------------------------------------------------
   // in my humble opinion these is only for have the same % values to
   // compare with the old one-way, using FX_factor...!!!
   max=max+old_gap-(max-min);
   // -------------------------------------------------------

   // for better view
   max=max+0.0002;
   min=min-0.0002;

   if(strcmp(argv_min,"-")) min=(atof(argv_min))*0.001;
   if(strcmp(argv_max,"-")) max=(atof(argv_max))*0.001;

   // start graphic
   gap=(max-min);
   real_size=graphic_points;
   real_step=gap/real_size;
   open_all_temp_files();
   for(countf=0; countf<fnum; countf++)
   {
      // yeahhh.....   3 hours to make this method !!!!  :)
      FX_factor=(old_min-min-average[countf])/real_step;
      while(!feof(faux[countf]))
      {
   	 fgets(line,256,faux[countf]);
	 if (feof(faux[countf])) break;
	 delay=atof(line);
         var=(delay-old_min)/real_step+FX_factor;
         if ( (var>graphic_points) || (var<0) )
         {
            printf(" fatal RANGE_VALUE error.....!!!");
//          exit(-1);
         }
         else  dist[countf][var]++;
      }
   }
   close_all_temp_files();
   f=fopen("graphDAT","w");
   for (countp=0; countp<=graphic_points; countp++)
   {
      fprintf(f,"%.2f ", (min+countp*real_step)*1000);  // time in msec
      for(countf=0; countf<fnum; countf++)              // axis-y  in %
      {
	 fprintf(f,"%f ",100*dist[countf][countp]/count_dat[countf]);
      }
      fprintf(f,"\n");
   }
   fclose(f);
}






// ########################################################################
// ------------------------------------------------------------------------
// ########################################################################
//                       M     A       I       N
// ########################################################################
// ------------------------------------------------------------------------
// ########################################################################
int main (int argc, char *argv[])
{

   if (argc < 6) {
     printf(" MGEN - Distribution generator:\n\nUsage: %s min max [- default] opt [0-4]  AnalisiType [1-2]  OutFile  size  InFile1 Flow .. InFileN Flow \n", argv[0]);
     exit(-1);
   }
// initvar
   graphic_points=atoi(argv[6]);
   fnum=(argc-first_file) /2;            // numero de ficheros de input

   max_SeqNum=0;
   min_SeqNum=9999;
   min=10000;
   max=0.000001;
   opt=*argv[3];
   strcpy(proc,"timeN_f0");
   strcpy(out_name,argv[5]);
   fout_name=&proc[0];
   strcpy(argv_min,argv[1]);
   strcpy(argv_max,argv[2]);

   for(countf=0; countf<fnum; countf++)
   {
      flow_max[countf]=0.000001;
      flow_min[countf]=10000;
   }
   for(countp=0; countp<=graphic_points; countp++)
      for(countf=0; countf<fnum; countf++)
        dist[countf][countp]=0;
   for(countp=0; countp<fnum; countp++)
   {
       faux[countp]=NULL;
       pack_size[countp]=0;   //pack_size de cada fichero
       count_dat[countp]=0;   //numero de mostras para cada punto
       average[countp]=0;
   }
// start program

// clrscr();
   printf("\n MGEN - DISTribution generator for Netmeter v2.0 \n\n");
   printf("\n list of parameters:");
   printf("\n - min = %s",argv[1]);
   printf("\n - max = %s",argv[2]);
   printf("\n - task option = %s",task[opt-'0']);
   printf("\n - transistory proces = %s",flag[*argv[4]-'0']);
   printf("\n - output files path  = ./%s/",DIRECTORY_FILE_OUT);
   printf("\n - output image name  = ./%s",argv[5]);
   printf("\n - graph size (pixel) = %s",argv[6]);
   printf("\n - ESP                = %s",argv[7]);
   printf("\n - XES                = %s",argv[8]);
   printf("\n - TY                 = %s",argv[9]);
   printf("\n - Fill               = %s",flag[*argv[10]-'0']);
   printf("\n - Zero               = %s",flag[*argv[11]-'0']);
   printf("\n - Layout             = %s",flag[*argv[12]-'0']);
   printf("\n - Pattern            = %s",argv[13]);
   printf("\n - number of input files %d \n",fnum);
   printf("\n - argv[%d]  = %s",first_file,argv[first_file]);
   if (fnum>=MAX_INPUT_FILES)
   {
       printf("\n Sorry, too Many input files ......!!!\n");
       exit(-1);
   }
   if (argc<first_file+1)
   {
      printf("\n MGEN - Distribution generator:\n\nUsage: %s min max [- default] opt [0-4]  AnalisiType [1-2]  OutFile  size  InFile1 Flow .. InFileN Flow \n", argv[0]);
      exit (-1);
   }
   printf("\n\n list of input files [with specifed fixed flow] :-)  ");
   for(countk=0; countk<fnum; countk++)
   {
     printf("\n - input file name = %s  ",argv[countk*2+first_file]);
     printf("\n - flow number     = %s  ",argv[countk*2+first_file+1]);
   }

   if (chdir(DIRECTORY_FILE_OUT))
   {
      mkdir(DIRECTORY_FILE_OUT);
      chdir(DIRECTORY_FILE_OUT);
   }
   for(countk=0; countk<fnum; countk++)
   {
      strcpy(fnames[countk],argv[first_file+countk*2]);
        nflows[countk]=atoi(argv[first_file+countk*2+1]);
   }
   trans=*argv[4]-'0';

// printf("\n\n Do you want to process  (y/n):");
// if (getchar()!= 'y') exit(-1);
// ------------------------------------------------------------------------



   if (opt=='7')        // IPDV vs Time
   {
      maxf=0;
      minf=0;
      if (strcmp(argv_min,"-")) {  maxf=1; min=(atof(argv_min))*0.001; }
      if (strcmp(argv_max,"-")) {  minf=1; max=(atof(argv_max))*0.001; }
      fout=fopen("graphDAT","w");
   }


   for(countk=0; countk<fnum; countk++)
   {
      last_SeqNum=0;
      last=0;
      total_delay=0;
      fixed_flow=atoi(argv[first_file+countk*2+1]);
      check_input_file(argv[first_file+countk*2]);
      //printf("\n\n Debug");
      proc[4]= (char)(countk + '0');

      if (opt!='7')        // IPDV vs Time
        fout=fopen(fout_name,"w");   // generamos k ficheros "procK."

      if (*argv[4]=='0') for(count=0; count<TRANSITORY_LINES; count++)
      fgets(line,256,f);
      while(!feof(f))
      {
      	 fgets(line,256,f);
     	 if (feof(f))  break;
         strncpy(flownumber, &line[5], 4);
         read_flow=atoi(flownumber);
         if (read_flow==fixed_flow)
         {
             strncpy(seq,  &line[14],   6);
	     seq[6]='\0';
             SeqNum=atoi(seq);

             strncpy(hor1, &line[time_stamp_offset],   2);
             strncpy(min1, &line[time_stamp_offset+3], 2);
             strncpy(sec1, &line[time_stamp_offset+6], 9);
             strncpy(hor2, &line[time_stamp_offset+23],2);
             strncpy(min2, &line[time_stamp_offset+26],2);
             strncpy(sec2, &line[time_stamp_offset+29],9);
	     min1[2]='\0';
	     hor1[2]='\0';
             sec1[9]='\0';
	     min2[2]='\0';
	     hor2[2]='\0';
             sec2[9]='\0';
/*
             _hor1=atoi(hor1);
             _hor2=atoi(hor2);
             _min1=atoi(min1);
             _min2=atoi(min2);
             _sec1=atof(sec1);
             _sec2=atof(sec2);
             if (_sec2<_sec1) { _sec2+=60;   _min2--;  }
             if (_min2<_min1) { _min2+=60;   _hor2--;  }

             temp=(_hor2-_hor1)*3600+(_min2-_min1)*60;
//             temp=(_hor2-_hor1)*3600+(_min2-_min1)*60;
             delay=_sec2-_sec1;
             delay+=temp;
*/
              temp=(atoi(hor2)-atoi(hor1))*3600 +(atoi(min2)-atoi(min1))*60;

              _sec1=atof(sec2)-atof(sec1);
              delay=_sec1+temp;

             if (opt=='6') // (OW-DELAY COMPARE)
             {
	        if (delay<min)  min=delay;
	        if (delay>max)  max=delay;
	        if (delay<flow_min[countk] )  flow_min[countk]=delay;
	        if (delay>flow_max[countk] )  flow_max[countk]=delay;
   	        fprintf(fout,"%f\n",delay);
	        count_dat[countk]++;
             }
             else if (opt=='7')      // IPDV vs time
             {
      	        if(last!=0)
                {
                   if (SeqNum==last_SeqNum+1)
                   {
                      //if (SeqNum>max_SeqNum) max_SeqNum=SeqNum;
                      //if (SeqNum<min_SeqNum) min_SeqNum=SeqNum;
 	              ipdv=(last-delay);  // IPDVi = Di - Dj  (i=j+1)
	              //if (ipdv<min) min=ipdv;
	              //if (ipdv>max) max=ipdv;
                      if  ( ( (minf==0) || (ipdv>=min) ) &&
                            ( (maxf==0) || (ipdv<=max) )    )
        	          fprintf(fout,"%d %f \n",SeqNum,ipdv);
	              //count_dat[countk]++;
                   }
                   else
                      printf("\n [packet dropped] Packet out of Sequence on n. %d",SeqNum);
                }
             }
             else if ((opt=='0') || (opt=='4')) // (OW-DELAY) or (HEAD)
             {
                //printf("\n OneWay DELAY OK");
	        if (delay<min)  min=delay;
	        if (delay>max)  max=delay;
   	        fprintf(fout,"%f\n",delay);
	        count_dat[countk]++;
             }
             else if (opt=='1')      // IPDV
             {
                //printf("\n IPDV DELAY OK");
      	        if(last!=0)
                {
                   if (SeqNum==last_SeqNum+1)
                   {
 	              ipdv=last-delay;            // IPDVi = Di - Dj  (i=j+1)
                      if ((ipdv<-0.5) || (ipdv>100))
                       ipdv=ipdv;
	              if (ipdv<min) min=ipdv;
	              if (ipdv>max) max=ipdv;
   	              fprintf(fout,"%f\n",ipdv);
	              count_dat[countk]++;
                   }
                   else
                      printf("\n [packet dropped] Packet out of Sequence on n. %d",SeqNum);
                }
             }
             else               // UPDATE_MCL
             {
	        count_dat[countk]++;
   	        fprintf(fout,"%f\n",delay);
             }
 	     total_delay=total_delay+delay; // expressed in msec
	     //printf(" - counter %f - delay: %f  -  totaldelay: %f \n",count_dat[countk],delay, total_delay);
             last=delay;
             last_SeqNum=SeqNum;
         }
      }
      fclose(f);
      if (opt=='7')        // IPDV vs Time
      {
         fprintf(fout,"NEW\n");
         average[countk]=total_delay/count_dat[countk];
         printf("\n  pack_size %d - average delay (msec *1000) %d: %f\n",pack_size[countk],average[countk]);
      }
      else
      {
         fclose(fout);
         average[countk]=total_delay/count_dat[countk];
         printf("\n  pack_size %d - average delay (sec): %f \n",pack_size[countk],average[countk]);
      }
   }
   if (opt=='7')        // IPDV vs Time
   {
      fclose(fout);
   }
// ------------------------------------------------------------------------
   if (opt!='6')
   {
      if(strcmp(argv_min,"-")) min=(atof(argv_min))*0.001;
      if(strcmp(argv_max,"-")) max=(atof(argv_max))*0.001;
   }
   if      (opt=='4')  process_HEAD();
   else if (opt=='5')  process_UPDATE_MCL();
   else if (opt=='6')  process_ONEWAY_COMPARE();
   else if (opt=='7')  ;
   else                process_IPDV_ONEWAY();

// ------------------------------------------------------
//   MAKE file "cgraf"  de configuracion del grafico
// ------------------------------------------------------

   f=fopen("cgraph","w");
   fprintf(f,"ESP %s\n",argv[7]);
   fprintf(f,"XES %s\n",argv[8]);
   fprintf(f,"TY %s\n",argv[9]);

//   if ((opt=='0') || (opt=='1') ||(opt=='7') || (opt=='6'))  // One-way x 2 + IPDV
   {   
      if (*argv[10]=='1') fprintf(f,"RFILL ON\n");
      if (*argv[12]=='1') fprintf(f,"RBACK ON\n");
      if (*argv[13]!='-') fprintf(f,"RPATTERN %s\n",argv[13]);
   }
   if ((opt=='1') || (opt=='6') )     // IPDV distribution + ONE WAY compare
   {   
      if (*argv[11]=='1') fprintf(f,"RZERO ON\n");
   }       
   if (opt=='7')      // IPDV   
   {   
       fprintf(f,"TYPE X\n");                // the my X-type  ;)
       fprintf(f,"RXSIZE %s\n",argv[6]);
       fprintf(f,"RYSIZE %s\n",argv[9]);
   }       
   else fprintf(f,"TYPE N\n");
   fprintf(f,"Lab 0\n");
   fprintf(f,"Font FS\n");
   fprintf(f,"Output %s\n",argv[5]);
   fprintf(f,"Input %s",DIRECTORY_FILE_OUT);
   fprintf(f,"/graphDAT\n");
   if (opt=='7') 
   {   
      fprintf(f,"Dat 1");
   }
   else
   {
      fprintf(f,"Dat ");
      for (countp=1; countp<=fnum;countp++) fprintf(f," %d",countp);
   }      
   fprintf(f,"\nLegend Este FM ");
   for (countp=0; countp<fnum; countp++)
   {
      if (opt=='6') {
         sprintf(line,"+Average delay (msec): %.2f",average[countp]*1000);
         strcat(flow_title[countp],line);
      }
      fprintf(f," ?%s!",flow_title[countp]);
   }
   fprintf(f,"\nTitle Oeste FM %s",Ytitle[opt-'0']);
   fprintf(f,"\nTitle Sur FM %s",Xtitle[opt-'0']);
   fprintf(f,"\nEJE flt");
   fprintf(f,"\nTitle Norte FM %s",task[opt-'0']);
   fclose(f);
   chdir("..");
}





